/*
 * Component_List.java
 *
 * Created on Utorok, 2008, marec 18, 20:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package elcuit;

import java.util.LinkedList;
import java.util.ListIterator;

/**
 *
 * @author pc
 */
public class Component_List {
    
    /** Creates a new instance of Component_List */
    public Component_List() {
    }
    
    private LinkedList<AComponent> ll = new LinkedList<AComponent>();
    private LinkedList<Wire> ll2 = new LinkedList<Wire>();
    
    public LinkedList<AComponent> zoznam(){
        return ll;
    }
    
    public LinkedList<Wire> vodice(){
        return ll2;
    }
    
    public void add (AComponent c, int x, int y) {
        c.nastav_suradnice(x, y);
        if(!hit_comp(c)) ll.add(c);
    }
    
    public void add_vodic (Wire w) {
        ll2.add(w);
    }
    
    public boolean hit_sth(int x, int y){
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c != null) {
                if(c.hit (x, y)){
                    return true;
                }
            }   
        }
        return false;
    }
    
    public boolean hit_comp(AComponent s){
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if ((c != null)&&(c != s)) {
                if(c.hits (s)){
                    return true;
                }
            }   
        }
        return false;
    }

    public AComponent hit_r(int x, int y) {
        AComponent c = null;
        for (ListIterator<AComponent> it = zoznam().listIterator(); it.hasNext();) {
            c = it.next();
            if (c != null) {
                if(c.hit (x, y)){
                    return c;
                }
            }   
        }
        return null;
    }

    public void del (AComponent c) {
        ll.remove(c);
        for (ListIterator<Wire> it = vodice().listIterator(); it.hasNext();) {
            Wire w = it.next();
            if((w.comp1 == c) || (w.comp2 == c)) it.remove();
        }    
    }
    
     public void del_vodic (Wire w) {
        ll2.remove(w);
    }
}
